#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 29 09:11:57 2019

@author: stan
"""
from boolparse.BooleanSentenceListener import BooleanSentenceListener
from collections import deque
from boolparse.logic.logic import Var,TRUE,FALSE,Not,And,Or,Equivalence,Implication
class SentenceListener(BooleanSentenceListener):

    def __init__(self):
        self.pila = deque()
        self.vars = set()
    
    def exitTrueSentence(self, ctx):
        self.pila.append(TRUE())
        
    def exitFalseSentence(self, ctx):
       self.pila.append(FALSE())
        
    def exitAtomSentence(self, ctx):
        nombre = str(ctx.VAR())
        self.vars.add(nombre)
        self.pila.append(Var(nombre))
    
    def exitNotSentence(self,ctx):
        self.pila.append(Not(self.pila.pop()))
    
    def exitAndSentence(self, ctx):
        right = self.pila.pop()
        left = self.pila.pop()
        self.pila.append(And(left,right))
    
    def exitOrSentence(self, ctx):
        right = self.pila.pop()
        left = self.pila.pop()
        self.pila.append(Or(left,right))
    
    def exitEquivalenceSentence(self, ctx):
        right = self.pila.pop()
        left = self.pila.pop()
        self.pila.append(Equivalence(left,right))
    
    def exitImplicationSentence(self,ctx):
        right = self.pila.pop()
        left = self.pila.pop()
        self.pila.append(Implication(left,right))
        
    def get_expression(self):
        return self.pila.pop()
    
    def get_var_names(self):
        return sorted(self.vars)
